=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'date'

module WeFitter
  class DailySummary
    # Date of the summary.
    attr_accessor :date

    # Distance in meters.
    attr_accessor :distance

    # Steps taken.
    attr_accessor :steps

    # Calories burned.
    attr_accessor :calories

    # Active calorie burn.
    attr_accessor :active_calories

    # BMR calorie burn.
    attr_accessor :bmr_calories

    # Points earned.
    attr_accessor :points

    # Origin of the data.
    attr_accessor :source

    attr_accessor :heart_rate_summary

    attr_accessor :stress_summary

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'date' => :'date',
        :'distance' => :'distance',
        :'steps' => :'steps',
        :'calories' => :'calories',
        :'active_calories' => :'active_calories',
        :'bmr_calories' => :'bmr_calories',
        :'points' => :'points',
        :'source' => :'source',
        :'heart_rate_summary' => :'heart_rate_summary',
        :'stress_summary' => :'stress_summary'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'date' => :'Date',
        :'distance' => :'Float',
        :'steps' => :'Float',
        :'calories' => :'Float',
        :'active_calories' => :'Float',
        :'bmr_calories' => :'Float',
        :'points' => :'Float',
        :'source' => :'String',
        :'heart_rate_summary' => :'HeartRateSummaryLinked',
        :'stress_summary' => :'StressSummaryLinked'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'date')
        self.date = attributes[:'date']
      end

      if attributes.has_key?(:'distance')
        self.distance = attributes[:'distance']
      end

      if attributes.has_key?(:'steps')
        self.steps = attributes[:'steps']
      end

      if attributes.has_key?(:'calories')
        self.calories = attributes[:'calories']
      end

      if attributes.has_key?(:'active_calories')
        self.active_calories = attributes[:'active_calories']
      end

      if attributes.has_key?(:'bmr_calories')
        self.bmr_calories = attributes[:'bmr_calories']
      end

      if attributes.has_key?(:'points')
        self.points = attributes[:'points']
      end

      if attributes.has_key?(:'source')
        self.source = attributes[:'source']
      end

      if attributes.has_key?(:'heart_rate_summary')
        self.heart_rate_summary = attributes[:'heart_rate_summary']
      end

      if attributes.has_key?(:'stress_summary')
        self.stress_summary = attributes[:'stress_summary']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @date.nil?
        invalid_properties.push('invalid value for "date", date cannot be nil.')
      end

      if @source.nil?
        invalid_properties.push('invalid value for "source", source cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @date.nil?
      return false if @source.nil?
      source_validator = EnumAttributeValidator.new('String', ['AGGREGATED', 'ANDROID', 'APPLE', 'FITBIT', 'GARMIN', 'GOOGLEFIT', 'HEALTHCONNECT', 'HUAWEI', 'MYZONE', 'OMH', 'OMRON', 'OURA', 'POLAR', 'SAMSUNG', 'STRAVA', 'SUUNTO', 'WF', 'WHOOP', 'WITHINGS'])
      return false unless source_validator.valid?(@source)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] source Object to be assigned
    def source=(source)
      validator = EnumAttributeValidator.new('String', ['AGGREGATED', 'ANDROID', 'APPLE', 'FITBIT', 'GARMIN', 'GOOGLEFIT', 'HEALTHCONNECT', 'HUAWEI', 'MYZONE', 'OMH', 'OMRON', 'OURA', 'POLAR', 'SAMSUNG', 'STRAVA', 'SUUNTO', 'WF', 'WHOOP', 'WITHINGS'])
      unless validator.valid?(source)
        fail ArgumentError, 'invalid value for "source", must be one of #{validator.allowable_values}.'
      end
      @source = source
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          date == o.date &&
          distance == o.distance &&
          steps == o.steps &&
          calories == o.calories &&
          active_calories == o.active_calories &&
          bmr_calories == o.bmr_calories &&
          points == o.points &&
          source == o.source &&
          heart_rate_summary == o.heart_rate_summary &&
          stress_summary == o.stress_summary
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [date, distance, steps, calories, active_calories, bmr_calories, points, source, heart_rate_summary, stress_summary].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = WeFitter.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
